
#USER_CC = gcc
#USER_AR = ar
#USER_LD = ld
#USER_RANLIB = ranlib

#CFLAGS += -Wall -Wstrict-prototypes -Wno-trigraphs -fno-strict-aliasing -fno-common -pipe -mpreferred-stack-boundary=2 -march=i586

L26FLAGS := -Wall -Wstrict-prototypes -g -fshort-enums
L26FLAGS += -m32
L26FLAGS += -DL26
ifeq ($(COMPILE_ICNOVA),TRUE)
L26FLAGS += -DICNOVA
endif

LDFLAGS = -m32
LDFLAGS += -lpthread -lrt

%.linux: %.linux.o
	@echo "Linking \033[;33m$@"; tput sgr0 #Yellow
	$(USER_CC) -o $@ $^ -static $(LDFLAGS) $(LDFLAGS_$@)

%.linux.o: %.c
	@echo "Compiling \033[;34m$@"; tput sgr0 #Blue
	$(USER_CC) $(L26FLAGS) $(L26FLAGS_$@) -o $@ -c $<

%.linux.a:
	@echo -n "Packing \033[4m$@\033[0m  " #underline
	@rm -rf tmp ; mkdir tmp;
	@cd tmp; for lib in $(filter %.a,  $^); do $(USER_AR) x ../$$lib ; done; cd ..
	@x=`find ./tmp -name "*.o*"` ; $(USER_AR) cr $@ $$x $(filter %.o,  $^)
	@$(USER_RANLIB) $@
	@rm -rf tmp
	@echo "  \033[;32m OK"; tput sgr0 #Green

.d.%.linux.c: %.c
	@set -e; $(USER_CC) -MM $(L26FLAGS) $(L26FLAGS_$@) $< \
		| sed 's/\($*\)\.o[ :]*/\1.linux.o $@ : /g' > $@; \
		[ -s $@ ] || rm -f $@

