
USER_CC = $(PATH_TO_QNXNTO)/host/linux/x86/usr/bin/ntox86-gcc
USER_AR = $(PATH_TO_QNXNTO)/host/linux/x86/usr/bin/ntox86-ar
USER_LD = $(PATH_TO_QNXNTO)/host/linux/x86/usr/bin/ntox86-ld
USER_RANLIB = $(PATH_TO_QNXNTO)/host/linux/x86/usr/bin/ntox86-ranlib

QNXFLAGS := -Wall -Wstrict-prototypes -g -fshort-enums
#QNXFLAGS += -I$(PATH_TO_QNXNTO)/target/qnx6/usr/include
QNXFLAGS += -DQNX

LDFLAGS = -lsocket

%.qnx: %.qnx.o
	@echo "Linking \033[;33m$@"; tput sgr0 #Yellow
	$(USER_CC) -o $@ $^ -static $(LDFLAGS) $(LDFLAGS_$@)

%.qnx.o: %.c
	@echo "Compiling \033[;34m$@"; tput sgr0 #Blue
	$(USER_CC) $(QNXFLAGS) $(QNXFLAGS_$@) -o $@ -c $<

%.qnx.a:
	@echo -n "Packing \033[4m$@\033[0m  " #underline
	@rm -rf tmp ; mkdir tmp;
	@cd tmp; for lib in $(filter %.a,  $^); do $(USER_AR) x ../$$lib ; done; cd ..
	@x=`find ./tmp -name "*.o*"` ; $(USER_AR) cr $@ $$x $(filter %.o,  $^)
	@$(USER_RANLIB) $@
	@rm -rf tmp
	@echo "  \033[;32m OK"; tput sgr0 #Green

.d.%.qnx.c: %.c
	@set -e; $(USER_CC) -MM $(QNXFLAGS) $(QNXFLAGS_$@) $< \
		| sed 's/\($*\)\.o[ :]*/\1.qnx.o $@ : /g' > $@; \
		[ -s $@ ] || rm -f $@

