/*****************************************************************************
 * igmp.h:
 *****************************************************************************
 * Copyright (C) 2006-2012 the FTT-SE team.
 *
 * Author: Ricardo Marau <marau at fe.up.pt>
 *
 * FTT-SE is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  FTT-SE is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with FTT-SE.  If not, see <http://www.gnu.org/licenses/>.
 *****************************************************************************/

#ifndef IGMP_H
#define IGMP_H

#include "igmp.h"

#define IGMP_PROTOCOL	2

typedef struct ip_addr{
    unsigned char ad[4];
}  __attribute__ ((packed)) IP_ADDR;

extern unsigned char ip_str2addr(char *a, IP_ADDR *ip);

extern unsigned char ip_compAddr(IP_ADDR ip1, IP_ADDR ip2);

extern unsigned short IGMP_deassign_igmp_cmd(void *pkt, IP_ADDR *gda);

extern unsigned short IGMP_assign_igmp_cmd(void *pkt, IP_ADDR *gda);

extern void IGMP_set_ip(void *pkt, unsigned short len, IP_ADDR dest, unsigned short protocol_id);

extern unsigned short IGMP_sizeof(void);
extern unsigned short IGMP_frameSize(void);

extern unsigned char IGMP_isMulticast(unsigned char *mac);

extern void IGMP_setMulticastBase(unsigned char *mac);
#endif
