/*****************************************************************************
 * M_Dispatcher.h:
 *****************************************************************************
 * Copyright (C) 2006-2012 the FTT-SE team.
 *
 * Author: Ricardo Marau <marau at fe.up.pt>
 *
 * FTT-SE is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  FTT-SE is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with FTT-SE.  If not, see <http://www.gnu.org/licenses/>.
 *****************************************************************************/

/*! \page M_Dispatcher Master Dispatcher
 
  This is responsible for periodically sending the content in the ECReg in the form of the Trigger Message.
 
 */

#ifndef M_DISPATCHER_H
#define M_DISPATCHER_H

/** Initializes the Master Dispatcher. \return 0 - OK */
extern signed char M_DispatcherInit(unsigned char *mac_reg, unsigned long ec_period_reg);

/** Orders the Start of the Dispatcher.
 From then on, the Dispatcher is autonomous. It has it's own clock that periodically wakes the thread to process transmission of a new TM. After waking it fetches the content in "ECReg" builds the TM and orders the transmission to the network. After transmitting the TM and before going to sleep it sends a waking signal to the scheduler thread so it starts building the next EC. */
extern void M_DispatcherStartSystem(void);

/** Closes the Master Dispatcher.*/
extern void M_DispatcherClose(void);

#endif
