/*****************************************************************************
 * M_Ready_queue.h:
 *****************************************************************************
 * Copyright (C) 2006-2012 the FTT-SE team.
 *
 * Author: Ricardo Marau <marau at fe.up.pt>
 *
 * FTT-SE is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  FTT-SE is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with FTT-SE.  If not, see <http://www.gnu.org/licenses/>.
 *****************************************************************************/

#ifndef M_READY_QUEUE_H
#define M_READY_QUEUE_H

#include "M_db.h"

typedef struct ready_queue_idx{
	//TODO -define
	void *message_DB_pointer;
	unsigned int packets_no;
	unsigned char source_nodeID;
	struct ready_queue_idx *link;
}READY_QUEUE_IDX;

#define SRT_QUEUE	0
#define ART_H_QUEUE	1
#define ART_S_QUEUE	2
#define ART_U_QUEUE	3

typedef enum{
	SCHED_EDF=0,
	SCHED_RM,
	SCHED_DM,
	SCHEDD_FIFO
}SCHED_POLICIES;

extern signed char Ready_queues_Get_policy(unsigned char queue);

extern signed char Ready_queues_Init( void );
extern signed char Ready_queues_Init_check(void);

extern signed char ready_queue_watch_last_item(unsigned char queue_no, READY_QUEUE_IDX **item);

extern signed char ready_queue_decrease_last_item( unsigned char queue_no );

//////////////
extern signed char ready_queue_last_item_pointer(unsigned char queue_no, READY_QUEUE_IDX **item);
extern signed char ready_queue_next_item_pointer(READY_QUEUE_IDX **item);
extern signed char ready_queue_decrease_item_pointer( unsigned char queue_no, READY_QUEUE_IDX **item );
//////////////

/* To be called from M_Scheduler */
extern signed char ready_queue_get_activations_from_db(void);

/* To be called from M_db.c */
extern signed char ready_queue_remove_ID( unsigned char queue_no, unsigned short id )
;

#endif
