/*****************************************************************************
 * M_appPnP.h:
 *****************************************************************************
 * Copyright (C) 2006-2012 the FTT-SE team.
 *
 * Author: Ricardo Marau <marau at fe.up.pt>
 *
 * FTT-SE is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  FTT-SE is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with FTT-SE.  If not, see <http://www.gnu.org/licenses/>.
 *****************************************************************************/


/*! \page app_pnp Master Application Plug 'n Play handler
 This is responsible for capturing the event of new nodes coming or leaving the system. Then, the upper layer is able to block waiting for incoming or outgoing node events. This module is also responsible for compiling and sending formatted replies to the nodes stating whether the new node was added successfully.
 */

#ifndef  M_APPPNP_H
#define  M_APPPNP_H

/** Initializes the Master Application Plug 'n Play. \return 0 - OK */
extern signed char M_appPnP_Init(void);

/** Closes the Master Application Plug 'n Play. \return 0 - OK */
extern signed char M_appPnP_Close(void);

/** Let the new node append request be process. \return 0 - OK */
extern signed char M_appPnP_Append_request(signed short app_id, unsigned char nodeID);

/** Blocks waiting for the new events in the internal queue of events. \return 0 - OK */
extern signed char M_appPnP_Get_request_blocking(signed short *app_id, unsigned char *nodeID);

/** Notify back the Slave whether it was added successfully or not. \return 0 - OK */
extern signed char M_appPnP_notify_Slave(unsigned char ok, signed short app_id, unsigned char nodeID, unsigned short id_tx, unsigned short id_rx);


#endif
