/*****************************************************************************
 * M_eth_filter.h:
 *****************************************************************************
 * Copyright (C) 2006-2012 the FTT-SE team.
 *
 * Author: Ricardo Marau <marau at fe.up.pt>
 *
 * FTT-SE is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  FTT-SE is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with FTT-SE.  If not, see <http://www.gnu.org/licenses/>.
 *****************************************************************************/

/*! \page M_eth_filter Master Ehernet Filter 
 This is responsible for receiving all packets from the network card, decoding them individually and establishing the interactions with the different entities in the Master. For example, Slave Signaling commands are translated into "db" updates. */


#ifndef M_ETH_FILTER_H
#define M_ETH_FILTER_H

/** Initializes the Master Ethernet Filter. \return 0 - OK */
extern signed char M_eth_filter_Init(void);

/** Closes the Master Ethernet Filter. \return 0 - OK */
extern signed char M_eth_filter_Close(void);

#endif
