/*****************************************************************************
 * S_ECscheduled.h:
 *****************************************************************************
 * Copyright (C) 2006-2012 the FTT-SE team.
 *
 * Author: Ricardo Marau <marau at fe.up.pt>
 *
 * FTT-SE is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  FTT-SE is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with FTT-SE.  If not, see <http://www.gnu.org/licenses/>.
 *****************************************************************************/

#ifndef S_ECSCHEDULED_H
#define S_ECSCHEDULED_H

#include <time.h>

extern signed char S_ECScheduled_Init(void);

extern signed char S_ECScheduled_Close(void);

extern unsigned char S_ECScheduled_GetMessage( unsigned short *return_id, unsigned char *return_source_nodeID, unsigned short *return_frag_no );
extern unsigned char S_ECScheduled_PutSMessage( unsigned short id, unsigned char source_nodeID, unsigned short frag_no );
extern unsigned char S_ECScheduled_PutAMessage( unsigned short id, unsigned char source_nodeID, unsigned short frag_no );

extern unsigned char S_ECScheduled_GetSigRequest( unsigned short *return_nodeid, unsigned char *return_seq_no );
extern unsigned char S_ECScheduled_PutSigRequest( unsigned short nodeID, unsigned char seq_no );

extern void S_ECScheduled_CleanTables(void);
extern void S_ECScheduled_StoreTimestamp( struct timespec *timestamp );
extern struct timespec S_ECScheduled_ReadTimestamp( void );

#endif

