/*****************************************************************************
 * S_MACadd_table.c:
 *****************************************************************************
 * Copyright (C) 2006-2012 the FTT-SE team.
 *
 * Author: Ricardo Marau <marau at fe.up.pt>
 *
 * FTT-SE is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  FTT-SE is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with FTT-SE.  If not, see <http://www.gnu.org/licenses/>.
 *****************************************************************************/


#include "Ports.h"

#include "ethernet.layer.h"	//for the MAC associated functions
#include "ftt-global.h"		//for the SW_MAX_PORTS define

static unsigned char S_MACadd_table_init=0;

typedef struct{
	unsigned char mac_address[6];
	unsigned char in_use;
}MAC_TABLE;

static MAC_TABLE S_mac_table[SW_MAX_PORTS]; //the index refers to the node ID (there can't be more than 255 nodes)

signed char S_MACadd_table_Init(void)
{
	unsigned char temp_id;

	for (temp_id=0; temp_id<SW_MAX_PORTS; temp_id++)
		S_mac_table[temp_id].in_use = 0;

	/* Declare the module as initialized */
	S_MACadd_table_init = 1;
	return 0;
}

signed char S_MACadd_table_init_check(void)
{
	if (S_MACadd_table_init == 0)
		return -1;
	return 0;
}

void S_MACadd_table_update( unsigned char idx, unsigned char *input_mac)
{
	S_mac_table[idx].in_use = 1;
	ETH_L_CopyMAC_to_from (S_mac_table[idx].mac_address, input_mac);
	return ;
}


unsigned char *S_MACadd_table_getMAC( unsigned char idx )
{
	return S_mac_table[idx].mac_address;
}
