/*****************************************************************************
 * S_allocator.h:
 *****************************************************************************
 * Copyright (C) 2006-2012 the FTT-SE team.
 *
 * Author: Ricardo Marau <marau at fe.up.pt>
 *
 * FTT-SE is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  FTT-SE is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with FTT-SE.  If not, see <http://www.gnu.org/licenses/>.
 *****************************************************************************/

#ifndef S_ALLOCATOR_H
#define S_ALLOCATOR_H

typedef signed short ALLOC_ID;

extern signed char Allocator_init(void);
extern signed char Allocator_close(void);
extern signed char AllocatorInit_check(void);
extern unsigned int Allocator_get_memory_size_needed(unsigned int dim_mes, unsigned char num_mes);


extern ALLOC_ID cab_create(unsigned int dim_mes, unsigned char num_mes, void *memory_point, unsigned int mem_size );
extern void cab_delete(ALLOC_ID id);
extern unsigned char *cab_reserve(ALLOC_ID id);
extern signed char cab_reserve_abort(ALLOC_ID id, void *pbuf);
#ifdef QNX_TAGGING
extern signed char cab_putmes(ALLOC_ID id, void *pbuf, unsigned int qnx_tag);
extern signed char cab_unget(ALLOC_ID id, void *pun_mes, unsigned int *ret_qnx_tag);
#else
extern signed char cab_putmes(ALLOC_ID id, void *pbuf);
extern signed char cab_unget(ALLOC_ID id, void *pun_mes);
#endif
extern unsigned char *cab_getmes(ALLOC_ID id);
extern void cab_print_all(void);

extern ALLOC_ID fifo_create(unsigned int dim_mes, unsigned char num_mes, void *memory_point, unsigned int mem_size );
extern void fifo_delete(ALLOC_ID id);
extern unsigned char *fifo_reserve(ALLOC_ID id, unsigned char blocking);
extern signed char fifo_reserve_abort(ALLOC_ID id, void *pbuf);
#ifdef QNX_TAGGING
extern signed char fifo_putmes(ALLOC_ID id, void *pbuf, unsigned int qnx_tag);
extern signed char fifo_unget(ALLOC_ID id, void *pun_mes, unsigned int *ret_qnx_tag);
#else
extern signed char fifo_putmes(ALLOC_ID id, void *pbuf);
extern signed char fifo_unget(ALLOC_ID id, void *pun_mes);
#endif
extern unsigned char *fifo_getmes(ALLOC_ID id);
extern signed short fifo_size(ALLOC_ID id);
extern signed short fifo_is_loaded(ALLOC_ID id);
extern void fifo_print(ALLOC_ID id);
extern void fifo_print_all(void);

#endif


