/*****************************************************************************
 * S_db.h:
 *****************************************************************************
 * Copyright (C) 2006-2012 the FTT-SE team.
 *
 * Author: Ricardo Marau <marau at fe.up.pt>
 *
 * FTT-SE is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  FTT-SE is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with FTT-SE.  If not, see <http://www.gnu.org/licenses/>.
 *****************************************************************************/

#ifndef NDB_H
#define NDB_H

#include "ftt-global.h"
#include "S_allocator.h"
#include "ftt-core.layer_types.h"


extern signed char NDB_add_msg(
		MESSAGE_TYPE m_type,
		unsigned short m_id,
		unsigned char m_tag,
		unsigned int m_size,
		unsigned int m_max_size,
		unsigned int m_period,
		unsigned short m_MTU,
		unsigned char *m_prod_mac,
		unsigned char m_prod_max_no);

extern signed char NDB_bind_mesg(
		MESSAGE_TYPE m_type,
		unsigned short m_id,
		FTT_SIGNAL **ret_callback_signal,
		void *memory_point,
		unsigned int mem_size,
		unsigned char slots_no
		);

extern signed char NDB_unbind_mesg(
		MESSAGE_TYPE m_type,
		unsigned short m_id);

extern signed char NDB_isbind_mesg(
		MESSAGE_TYPE m_type,
		unsigned short m_id);

extern signed char NDB_get_current(
		MESSAGE_TYPE m_type,
		unsigned int m_id,
		unsigned char *tag,
		unsigned int *cur_size,
		unsigned int *max_size,
		unsigned short *period );

extern signed char NDB_get_memory_pool_size(
		MESSAGE_TYPE m_type,
		unsigned int m_id,
		unsigned char slots_no,
		unsigned short *ret_mem_size );

extern signed char NDB_del_msg( unsigned char m_type, unsigned short m_id);

extern signed char NDB_clean_msg_tag( unsigned char m_type, unsigned short m_id, unsigned char m_tag);

extern signed char NDB_Init( void );

extern signed char NDB_Close(void);

extern signed char NDB_table_print( void );

extern signed char NDB_get_data2tx(
		unsigned short MesgID, 
		unsigned short frag_requested,
		unsigned char *mesg_value, 
		unsigned short *dm_len, 
		unsigned char *mesg_seqn, 
		unsigned short *frag_seqn,
#ifdef QNX_TAGGING
		QNX_TAGGING_TYPE *tagging,
#endif 
		FTT_SIGNAL **callback_sig );

extern signed char NDB_set_data2rx(
		unsigned short MesgID,
		unsigned char  source_nodeID,
		unsigned short frag_requested,
		unsigned char *mesg_value, 
		unsigned char mesg_tx_new_flag,
#ifdef QNX_TAGGING
		QNX_TAGGING_TYPE tagging,
#endif 								   
		struct rtl_timespec rxtimestamp);

extern signed char NDB_test_produce_and_bind(unsigned short MesgID, unsigned char **dest_mac);
extern signed char NDB_test_consume_and_bind(unsigned short MesgID);
extern signed char NDB_test_consumer_get_mac(unsigned char m_type, unsigned short m_id, unsigned char *mac);


extern signed char NDB_pre_produce(unsigned short MesgID, unsigned char **return_p);
extern signed char NDB_pre_produce_abort(unsigned short MesgID);
extern signed char NDB_produce(unsigned short MesgID, unsigned char tag, void *mesg_value);
extern signed char NDB_consume_status( unsigned short MesgID );
extern unsigned char *NDB_pre_consume(unsigned short MesgID, unsigned char *ret_tag, unsigned char *ret_status );
extern signed char NDB_consume(unsigned short MesgID, unsigned char *ret_tag, unsigned char *mesg_value, unsigned char *ret_status );

extern signed char NDB_pre_send(unsigned short MesgID, unsigned char alloc_block, unsigned char **return_p);
extern signed char NDB_pre_send_abort(unsigned short MesgID);
extern signed char NDB_send(unsigned short MesgID, unsigned char tag, void *mesg_value, unsigned char alloc_block);
extern signed char NDB_receive_status(unsigned short MesgID );
extern unsigned char *NDB_pre_receive(unsigned short MesgID, unsigned char *ret_tag, unsigned char *ret_status );
extern signed char NDB_receive(unsigned short MesgID, unsigned char *ret_tag, unsigned char *mesg_value, unsigned char *ret_status );


typedef struct{
	unsigned short tagged_id;
	unsigned char num;
}NDB_AM_Get_sent_RETURN_TYPE;

extern void NDB_AM_Get_sent(NDB_AM_Get_sent_RETURN_TYPE *p, unsigned short *size);

	


#endif
