/*****************************************************************************
 * S_igmp_queue.h:
 *****************************************************************************
 * Copyright (C) 2006-2012 the FTT-SE team.
 *
 * Author: Ricardo Marau <marau at fe.up.pt>
 *
 * FTT-SE is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  FTT-SE is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with FTT-SE.  If not, see <http://www.gnu.org/licenses/>.
 *****************************************************************************/

#ifndef S_IGMP_QUEUE_H
#define S_IGMP_QUEUE_H
#include "igmp.h"

extern signed char S_igmp_queue_init(void);

extern void S_igmp_queue_close(void);

extern signed char S_igmp_queue_put_message( unsigned char *msg, unsigned short len );

extern signed char S_igmp_queue_get_message(unsigned char *mesg_rcv, unsigned short *len);

extern signed char S_igmp_queue_send_report_if_multicast( unsigned char *mesg_mac, unsigned char *my_mac );

extern signed char S_igmp_queue_send_leave_if_multicast( unsigned char *mesg_mac, unsigned char *my_mac );

extern void S_igmp_queue_flush_queue(void);

#endif



