/*****************************************************************************
 * S_master_ch.h:
 *****************************************************************************
 * Copyright (C) 2006-2012 the FTT-SE team.
 *
 * Author: Ricardo Marau <marau at fe.up.pt>
 *
 * FTT-SE is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  FTT-SE is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with FTT-SE.  If not, see <http://www.gnu.org/licenses/>.
 *****************************************************************************/

/*! \page S_master_ch Slave Master Channel
 This is responsible for establishing the connection with the Master in order to receive the synchronization updates for the local database.
 
 Once initialized, this module becomes autonomous, being hooked up to the reception of the broadcast asynchronous channel.
 
 See also \ref M_master_ch .
 */


#ifndef S_MASTER_CH_H
#define S_MASTER_CH_H

/** Initializes the Slave Master channel. \return 0 - OK */
extern signed char S_master_ch_Init(void);

/** Closes the Slave Master channel. \return 0 - OK */
extern signed char S_master_ch_Close(void);
#endif
