/*****************************************************************************
 * S_nodeID.c:
 *****************************************************************************
 * Copyright (C) 2006-2012 the FTT-SE team.
 *
 * Author: Ricardo Marau <marau at fe.up.pt>
 *
 * FTT-SE is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  FTT-SE is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with FTT-SE.  If not, see <http://www.gnu.org/licenses/>.
 *****************************************************************************/


#include "ethernet.layer.h"

static signed short S_nodeID;

static unsigned char my_mac[6];
static unsigned char master_mac[6];	//otp - one time programmable

void S_nodeID_write(unsigned char id)
{
	S_nodeID = id;
	return;
}

signed short S_nodeID_read(void)
{
	return S_nodeID;
}

signed char S_nodeID_Init(unsigned char *mac)
{
	unsigned char j;
	S_nodeID = -1;

	/* Get my MAC */
	for (j=0; j<6; j++) 
		my_mac[j] = mac[j];

	return 0;
}

signed char S_nodeID_Close(void)
{
	return 0;
}

unsigned char *S_Get_My_mac(void)
{
	return my_mac;
}
unsigned char *S_Get_Master_mac(void)
{
//	if (S_nodeID != -1)
	return master_mac;
}

void S_Set_Master_mac(unsigned char *mac)
{

	if (S_nodeID != -1)
		return;
	S_nodeID = -2;
	ETH_L_CopyMAC_to_from( master_mac, mac );

	return ;
}


