/*****************************************************************************
 * S_int_req_dispatch.h:
 *****************************************************************************
 * Copyright (C) 2006-2012 the FTT-SE team.
 *
 * Author: Ricardo Marau <marau at fe.up.pt>
 *
 * FTT-SE is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  FTT-SE is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with FTT-SE.  If not, see <http://www.gnu.org/licenses/>.
 *****************************************************************************/

#ifndef  S_INT_REQ_DISPATCH_H
#define  S_INT_REQ_DISPATCH_H
#include "request_cmds.h"

extern signed char S_int_req_dispatch_Init(void);
extern signed char S_int_req_dispatch_Close(void);

extern signed char S_int_req_dispatch_GroupPrepare(void);
extern signed char S_int_req_dispatch_GroupSubmit(void);

extern signed char S_int_req_dispatch_CmdAdd(
		M_INT_APP_MSG_ID *app_msg_id,
		unsigned int *mesg_size,
		unsigned int *mesg_max_size,
		unsigned char *mesg_max_prod_no,
		unsigned short *mesg_period,
		unsigned short *mesg_MTU,
		unsigned char mesg_producers_no,
		unsigned char *mesg_producerID,
		unsigned char mesg_consumers_no,
		unsigned char *mesg_consumerID
		);

extern signed char S_int_req_dispatch_CmdDel(
		M_INT_APP_MSG_ID *app_msg_id
		);

extern signed int S_int_req_dispatch_CmdAddLoad(
		M_INT_APP_MSG_ID *app_msg_id,
		unsigned int *mesg_size,
		unsigned int *mesg_max_size,
		unsigned char *mesg_max_prod_no,
		unsigned short *mesg_period,
		unsigned short *mesg_MTU
		);

extern signed int S_int_req_dispatch_CmdAddQoS(
		M_INT_APP_MSG_ID *app_msg_id,
		signed int *mesg_size,
		signed int *mesg_period,
		signed short *mesg_priority
		);

extern signed int S_int_req_dispatch_CmdAddQoS_pair(
		M_INT_APP_MSG_ID *app_msg_id,
		signed int *mesg_size,
		signed int *mesg_period
		);

extern signed int S_int_req_dispatch_CmdRemoveLoad(	M_INT_APP_MSG_ID *app_msg_id);

extern signed int S_int_req_dispatch_CmdAddconnection(
		M_INT_APP_MSG_ID *app_msg_id,
		unsigned char *mesg_prodconsID,
		unsigned char direction
		);

extern signed int S_int_req_dispatch_CmdDelconnection(
		M_INT_APP_MSG_ID *app_msg_id,
		unsigned char *mesg_prodconsID
		);

extern signed int S_int_req_dispatch_CmdDetailConnection(
		M_INT_APP_MSG_ID *app_msg_id
		);

extern signed char S_int_req_dispatch_CmdChangePeriod(
		M_INT_APP_MSG_ID *app_msg_id,
		unsigned short *mesg_period);

extern signed char S_int_req_dispatch_CmdChangeQoS_prio(
		M_INT_APP_MSG_ID *app_msg_id,
		unsigned short prio);

extern signed char S_int_req_dispatch_CmdREQ_REMOTE_REPORT( void );

#endif
